Index: /trunk/NEMO/OPA_SRC/prtctl.F90
===================================================================
--- /trunk/NEMO/OPA_SRC/prtctl.F90	(revision 425)
+++ /trunk/NEMO/OPA_SRC/prtctl.F90	(revision 426)
@@ -145,8 +145,8 @@
                njctle = nlejtl(jn) + overlap * MIN( 1, nlcjtl(jn) - nlejtl(jn))
                ! Do not take into account the bound of the domain
-               IF( ibonitl(jn) == -1 ) nictls = MAX(2, nictls)
-               IF( ibonitl(jn) ==  1 ) nictle = MIN(nictle, nleitl(jn) - 1)
-               IF( ibonjtl(jn) == -1 ) njctls = MAX(2, njctls)
-               IF( ibonjtl(jn) ==  1 ) njctle = MIN(njctle, nlejtl(jn) - 1)
+               IF( ibonitl(jn) == -1 .OR. ibonitl(jn) == 2 ) nictls = MAX(2, nictls)
+               IF( ibonjtl(jn) == -1 .OR. ibonjtl(jn) == 2 ) njctls = MAX(2, njctls)
+               IF( ibonitl(jn) ==  1 .OR. ibonitl(jn) == 2 ) nictle = MIN(nictle, nleitl(jn) - 1)
+               IF( ibonjtl(jn) ==  1 .OR. ibonjtl(jn) == 2 ) njctle = MIN(njctle, nlejtl(jn) - 1)
             ELSE
                nictls = MAX( 1, nimpptl(jn) + nlditl(jn) - 1 - overlap )
@@ -155,8 +155,8 @@
                njctle = njmpptl(jn) + nlejtl(jn) - 1 + overlap * MIN( 1, nlcjtl(jn) - nlejtl(jn) ) 
                ! Do not take into account the bound of the domain
-               IF( ibonitl(jn) == -1 ) nictls = MAX(2, nictls)
-               IF( ibonjtl(jn) == -1 ) njctls = MAX(2, njctls)
-               IF( ibonitl(jn) ==  1 ) nictle = MIN(nictle, nimpptl(jn) + nleitl(jn) - 2)
-               IF( ibonjtl(jn) ==  1 ) njctle = MIN(njctle, njmpptl(jn) + nlejtl(jn) - 2)
+               IF( ibonitl(jn) == -1 .OR. ibonitl(jn) == 2 ) nictls = MAX(2, nictls)
+               IF( ibonjtl(jn) == -1 .OR. ibonjtl(jn) == 2 ) njctls = MAX(2, njctls)
+               IF( ibonitl(jn) ==  1 .OR. ibonitl(jn) == 2 ) nictle = MIN(nictle, nimpptl(jn) + nleitl(jn) - 2)
+               IF( ibonjtl(jn) ==  1 .OR. ibonjtl(jn) == 2 ) njctle = MIN(njctle, njmpptl(jn) + nlejtl(jn) - 2)
             ENDIF
          ENDIF
Index: /trunk/NEMO/TOP_SRC/prtctl_trc.F90
===================================================================
--- /trunk/NEMO/TOP_SRC/prtctl_trc.F90	(revision 425)
+++ /trunk/NEMO/TOP_SRC/prtctl_trc.F90	(revision 426)
@@ -129,8 +129,8 @@
                njctle = nlejtl(js) + overlap * MIN( 1, nlcjtl(js) - nlejtl(js))
                ! Do not take into account the bound of the domain
-               IF( ibonitl(js) == -1 ) nictls = MAX(2, nictls)
-               IF( ibonitl(js) ==  1 ) nictle = MIN(nictle, nleitl(js) - 1)
-               IF( ibonjtl(js) == -1 ) njctls = MAX(2, njctls)
-               IF( ibonjtl(js) ==  1 ) njctle = MIN(njctle, nlejtl(js) - 1)
+               IF( ibonitl(js) == -1 .OR. ibonitl(js) == 2 ) nictls = MAX(2, nictls)
+               IF( ibonitl(js) ==  1 .OR. ibonitl(js) == 2 ) nictle = MIN(nictle, nleitl(js) - 1)
+               IF( ibonjtl(js) == -1 .OR. ibonjtl(js) == 2 ) njctls = MAX(2, njctls)
+               IF( ibonjtl(js) ==  1 .OR. ibonjtl(js) == 2 ) njctle = MIN(njctle, nlejtl(js) - 1)
             ELSE
                nictls = MAX( 1, nimpptl(js) + nlditl(js) - 1 - overlap )
@@ -139,8 +139,8 @@
                njctle = njmpptl(js) + nlejtl(js) - 1 + overlap * MIN( 1, nlcjtl(js) - nlejtl(js) ) 
                ! Do not take into account the bound of the domain
-               IF( ibonitl(js) == -1 ) nictls = MAX(2, nictls)
-               IF( ibonjtl(js) == -1 ) njctls = MAX(2, njctls)
-               IF( ibonitl(js) ==  1 ) nictle = MIN(nictle, nimpptl(js) + nleitl(js) - 2)
-               IF( ibonjtl(js) ==  1 ) njctle = MIN(njctle, njmpptl(js) + nlejtl(js) - 2)
+               IF( ibonitl(js) == -1 .OR. ibonitl(js) == 2 ) nictls = MAX(2, nictls)
+               IF( ibonjtl(js) == -1 .OR. ibonjtl(js) == 2 ) njctls = MAX(2, njctls)
+               IF( ibonitl(js) ==  1 .OR. ibonitl(js) == 2 ) nictle = MIN(nictle, nimpptl(js) + nleitl(js) - 2)
+               IF( ibonjtl(js) ==  1 .OR. ibonjtl(js) == 2 ) njctle = MIN(njctle, njmpptl(js) + nlejtl(js) - 2)
             ENDIF
          ENDIF