Index: /trunk/CONFIG/GYRE/scripts/BB_make
===================================================================
--- /trunk/CONFIG/GYRE/scripts/BB_make	(revision 428)
+++ /trunk/CONFIG/GYRE/scripts/BB_make	(revision 429)
@@ -144,5 +144,4 @@
 		$(MODEL_LIB)(agrif_opa_sponge.o)\
 		$(MODEL_LIB)(agrif_opa_update.o)\
-		$(MODEL_LIB)(agrif_user.o)\
 		$(MODEL_LIB)(albedo.o)\
 		$(MODEL_LIB)(blk_oce.o)\
@@ -524,206 +523,4 @@
 		@if [ -f $(PREF)$*.L ] ; then mv $*.L $(TMP) ; fi
 
-$(MODEL_LIB)(agrif_opa_interp.o) :	\
-	in_out_manager.F90 \
-	lib_print.f90 \
-	par_kind.F90 \
-	par_oce.F90 \
-	$(MODEL_LIB)(in_out_manager.o) \
-	$(MODEL_LIB)(lib_print.o) \
-	$(MODEL_LIB)(par_kind.o) \
-	$(MODEL_LIB)(par_oce.o) \
-	dom_oce.F90 \
-	in_out_manager.F90 \
-	oce.F90 \
-	par_oce.F90 \
-	phycst.F90 \
-	sol_oce.F90 \
-	$(MODEL_LIB)(dom_oce.o) \
-	$(MODEL_LIB)(in_out_manager.o) \
-	$(MODEL_LIB)(oce.o) \
-	$(MODEL_LIB)(par_oce.o) \
-	$(MODEL_LIB)(phycst.o) \
-	$(MODEL_LIB)(sol_oce.o) \
-	domzgr_substitute.h90 \
-	vectopt_loop_substitute.h90 \
-	KEY_CPP \
-	agrif_opa_interp.F90
-$(MODEL_LIB)(agrif_opa_sponge.o) :	\
-	par_kind.F90 \
-	par_oce.F90 \
-	$(MODEL_LIB)(par_kind.o) \
-	$(MODEL_LIB)(par_oce.o) \
-	dom_oce.F90 \
-	oce.F90 \
-	par_oce.F90 \
-	$(MODEL_LIB)(dom_oce.o) \
-	$(MODEL_LIB)(oce.o) \
-	$(MODEL_LIB)(par_oce.o) \
-	domzgr_substitute.h90 \
-	KEY_CPP \
-	agrif_opa_sponge.F90
-$(MODEL_LIB)(agrif_opa_update.o) :	\
-	dom_oce.F90 \
-	in_out_manager.F90 \
-	lbclnk.F90 \
-	lib_mpp.F90 \
-	obc_oce.F90 \
-	ocesbc.F90 \
-	oce.F90 \
-	par_kind.F90 \
-	par_oce.F90 \
-	prtctl.F90 \
-	$(MODEL_LIB)(dom_oce.o) \
-	$(MODEL_LIB)(in_out_manager.o) \
-	$(MODEL_LIB)(lbclnk.o) \
-	$(MODEL_LIB)(lib_mpp.o) \
-	$(MODEL_LIB)(obc_oce.o) \
-	$(MODEL_LIB)(ocesbc.o) \
-	$(MODEL_LIB)(oce.o) \
-	$(MODEL_LIB)(par_kind.o) \
-	$(MODEL_LIB)(par_oce.o) \
-	$(MODEL_LIB)(prtctl.o) \
-	cla_div.F90 \
-	divcur.F90 \
-	dom_oce.F90 \
-	oce.F90 \
-	ocfzpt.F90 \
-	par_oce.F90 \
-	wzvmod.F90 \
-	$(MODEL_LIB)(cla_div.o) \
-	$(MODEL_LIB)(divcur.o) \
-	$(MODEL_LIB)(dom_oce.o) \
-	$(MODEL_LIB)(oce.o) \
-	$(MODEL_LIB)(ocfzpt.o) \
-	$(MODEL_LIB)(par_oce.o) \
-	$(MODEL_LIB)(wzvmod.o) \
-	domzgr_substitute.h90 \
-	KEY_CPP \
-	agrif_opa_update.F90
-$(MODEL_LIB)(agrif_user.o) :	\
-	blk_oce.F90 \
-	cla_div.F90 \
-	cpl.F90 \
-	cpl_oce.F90 \
-	daymod.F90 \
-	diaptr.F90 \
-	divcur.F90 \
-	domain.F90 \
-	domcfg.F90 \
-	dom_oce.F90 \
-	dtasal.F90 \
-	dtasst.F90 \
-	dtatem.F90 \
-	dyncor1d.F90 \
-	dynspg_oce.F90 \
-	eosbn2.F90 \
-	flxfwb.F90 \
-	iceini.F90 \
-	ini1d.F90 \
-	initrc.F90 \
-	in_out_manager.F90 \
-	istate.F90 \
-	ldfdyn.F90 \
-	ldftra.F90 \
-	lib_mpp.F90 \
-	lib_print.f90 \
-	mppini.F90 \
-	obcini.F90 \
-	obc_par.F90 \
-	oce.F90 \
-	ocfzpt.F90 \
-	par_kind.F90 \
-	par_oce.F90 \
-	phycst.F90 \
-	prtctl.F90 \
-	solver.F90 \
-	sol_oce.F90 \
-	step1d.F90 \
-	step.F90 \
-	traqsr.F90 \
-	trdicp.F90 \
-	trdmld.F90 \
-	trdmod.F90 \
-	trdmod_oce.F90 \
-	trdvor.F90 \
-	wzvmod.F90 \
-	zdfini.F90 \
-	zdfmxl.F90 \
-	zdf_oce.F90 \
-	zpshde.F90 \
-	$(MODEL_LIB)(blk_oce.o) \
-	$(MODEL_LIB)(cla_div.o) \
-	$(MODEL_LIB)(cpl.o) \
-	$(MODEL_LIB)(cpl_oce.o) \
-	$(MODEL_LIB)(daymod.o) \
-	$(MODEL_LIB)(diaptr.o) \
-	$(MODEL_LIB)(divcur.o) \
-	$(MODEL_LIB)(domain.o) \
-	$(MODEL_LIB)(domcfg.o) \
-	$(MODEL_LIB)(dom_oce.o) \
-	$(MODEL_LIB)(dtasal.o) \
-	$(MODEL_LIB)(dtasst.o) \
-	$(MODEL_LIB)(dtatem.o) \
-	$(MODEL_LIB)(dyncor1d.o) \
-	$(MODEL_LIB)(dynspg_oce.o) \
-	$(MODEL_LIB)(eosbn2.o) \
-	$(MODEL_LIB)(flxfwb.o) \
-	$(MODEL_LIB)(iceini.o) \
-	$(MODEL_LIB)(ini1d.o) \
-	$(MODEL_LIB)(initrc.o) \
-	$(MODEL_LIB)(in_out_manager.o) \
-	$(MODEL_LIB)(istate.o) \
-	$(MODEL_LIB)(ldfdyn.o) \
-	$(MODEL_LIB)(ldftra.o) \
-	$(MODEL_LIB)(lib_mpp.o) \
-	$(MODEL_LIB)(lib_print.o) \
-	$(MODEL_LIB)(mppini.o) \
-	$(MODEL_LIB)(obcini.o) \
-	$(MODEL_LIB)(obc_par.o) \
-	$(MODEL_LIB)(oce.o) \
-	$(MODEL_LIB)(ocfzpt.o) \
-	$(MODEL_LIB)(par_kind.o) \
-	$(MODEL_LIB)(par_oce.o) \
-	$(MODEL_LIB)(phycst.o) \
-	$(MODEL_LIB)(prtctl.o) \
-	$(MODEL_LIB)(solver.o) \
-	$(MODEL_LIB)(sol_oce.o) \
-	$(MODEL_LIB)(step1d.o) \
-	$(MODEL_LIB)(step.o) \
-	$(MODEL_LIB)(traqsr.o) \
-	$(MODEL_LIB)(trdicp.o) \
-	$(MODEL_LIB)(trdmld.o) \
-	$(MODEL_LIB)(trdmod.o) \
-	$(MODEL_LIB)(trdmod_oce.o) \
-	$(MODEL_LIB)(trdvor.o) \
-	$(MODEL_LIB)(wzvmod.o) \
-	$(MODEL_LIB)(zdfini.o) \
-	$(MODEL_LIB)(zdfmxl.o) \
-	$(MODEL_LIB)(zdf_oce.o) \
-	$(MODEL_LIB)(zpshde.o) \
-	agrif_opa_interp.F90 \
-	agrif_opa_sponge.F90 \
-	agrif_opa_update.F90 \
-	dom_oce.F90 \
-	ice_oce.F90 \
-	in_out_manager.F90 \
-	oce.F90 \
-	opa.F90 \
-	par_oce.F90 \
-	sol_oce.F90 \
-	tradmp.F90 \
-	$(MODEL_LIB)(agrif_opa_interp.o) \
-	$(MODEL_LIB)(agrif_opa_sponge.o) \
-	$(MODEL_LIB)(agrif_opa_update.o) \
-	$(MODEL_LIB)(dom_oce.o) \
-	$(MODEL_LIB)(ice_oce.o) \
-	$(MODEL_LIB)(in_out_manager.o) \
-	$(MODEL_LIB)(oce.o) \
-	$(MODEL_LIB)(opa.o) \
-	$(MODEL_LIB)(par_oce.o) \
-	$(MODEL_LIB)(sol_oce.o) \
-	$(MODEL_LIB)(tradmp.o) \
-	$() \
-	agrif_user.F90
 $(MODEL_LIB)(albedo.o) :	\
 	dom_oce.F90 \
@@ -1160,5 +957,5 @@
 	cpl_oce.F90
 \
-	$() $(MODEL_LIB)(daymod.o) :	\
+	$(AGRIF_LIB) $(MODEL_LIB)(daymod.o) :	\
 	dom_oce.F90 \
 	in_out_manager.F90 \
@@ -2532,6 +2329,4 @@
 	dynnxt1d.F90
 $(MODEL_LIB)(dynnxt.o) :	\
-	cla_div.F90 \
-	divcur.F90 \
 	dom_oce.F90 \
 	dynspg_oce.F90 \
@@ -2545,12 +2340,7 @@
 	ocesbc.F90 \
 	oce.F90 \
-	ocfzpt.F90 \
-	par_kind.F90 \
-	par_oce.F90 \
-	phycst.F90 \
-	sol_oce.F90 \
-	wzvmod.F90 \
-	$(MODEL_LIB)(cla_div.o) \
-	$(MODEL_LIB)(divcur.o) \
+	par_kind.F90 \
+	par_oce.F90 \
+	phycst.F90 \
 	$(MODEL_LIB)(dom_oce.o) \
 	$(MODEL_LIB)(dynspg_oce.o) \
@@ -2564,10 +2354,7 @@
 	$(MODEL_LIB)(ocesbc.o) \
 	$(MODEL_LIB)(oce.o) \
-	$(MODEL_LIB)(ocfzpt.o) \
-	$(MODEL_LIB)(par_kind.o) \
-	$(MODEL_LIB)(par_oce.o) \
-	$(MODEL_LIB)(phycst.o) \
-	$(MODEL_LIB)(sol_oce.o) \
-	$(MODEL_LIB)(wzvmod.o) \
+	$(MODEL_LIB)(par_kind.o) \
+	$(MODEL_LIB)(par_oce.o) \
+	$(MODEL_LIB)(phycst.o) \
 	agrif_opa_interp.F90 \
 	agrif_opa_update.F90 \
@@ -2594,5 +2381,5 @@
 	$(MODEL_LIB)(oce.o) \
 	$(MODEL_LIB)(prtctl.o) \
-	$() \
+	$(AGRIF_LIB) \
 	dynnxt.F90
 $(MODEL_LIB)(dynspg.o) :	\
@@ -2990,5 +2777,5 @@
 	domzgr_substitute.h90 \
 	vectopt_loop_substitute.h90 \
-	$() \
+	$(AGRIF_LIB) \
 	KEY_CPP \
 	dynspg_flt.F90
@@ -3109,5 +2896,5 @@
 	$(MODEL_LIB)(zdf_oce.o) \
 	domzgr_substitute.h90 \
-	$() \
+	$(AGRIF_LIB) \
 	KEY_CPP \
 	dynspg_flt_jki.F90
@@ -7641,5 +7428,5 @@
 	domzgr_substitute.h90 \
 	zdfddm_substitute.h90 \
-	$() \
+	$(AGRIF_LIB) \
 	KEY_CPP \
 	step.F90
@@ -8613,6 +8400,4 @@
 	tranpc.F90
 $(MODEL_LIB)(tranxt.o) :	\
-	cla_div.F90 \
-	divcur.F90 \
 	dom_oce.F90 \
 	in_out_manager.F90 \
@@ -8622,12 +8407,7 @@
 	obc_oce.F90 \
 	oce.F90 \
-	ocfzpt.F90 \
-	par_kind.F90 \
-	par_oce.F90 \
-	phycst.F90 \
-	sol_oce.F90 \
-	wzvmod.F90 \
-	$(MODEL_LIB)(cla_div.o) \
-	$(MODEL_LIB)(divcur.o) \
+	par_kind.F90 \
+	par_oce.F90 \
+	phycst.F90 \
 	$(MODEL_LIB)(dom_oce.o) \
 	$(MODEL_LIB)(in_out_manager.o) \
@@ -8637,10 +8417,7 @@
 	$(MODEL_LIB)(obc_oce.o) \
 	$(MODEL_LIB)(oce.o) \
-	$(MODEL_LIB)(ocfzpt.o) \
-	$(MODEL_LIB)(par_kind.o) \
-	$(MODEL_LIB)(par_oce.o) \
-	$(MODEL_LIB)(phycst.o) \
-	$(MODEL_LIB)(sol_oce.o) \
-	$(MODEL_LIB)(wzvmod.o) \
+	$(MODEL_LIB)(par_kind.o) \
+	$(MODEL_LIB)(par_oce.o) \
+	$(MODEL_LIB)(phycst.o) \
 	agrif_opa_interp.F90 \
 	agrif_opa_update.F90 \
@@ -8661,5 +8438,5 @@
 	$(MODEL_LIB)(prtctl.o) \
 	$(MODEL_LIB)(zdf_oce.o) \
-	$() \
+	$(AGRIF_LIB) \
 	tranxt.F90
 $(MODEL_LIB)(traqsr.o) :	\
Index: /trunk/CONFIG/ORCA2_LIM/scripts/BB_make
===================================================================
--- /trunk/CONFIG/ORCA2_LIM/scripts/BB_make	(revision 428)
+++ /trunk/CONFIG/ORCA2_LIM/scripts/BB_make	(revision 429)
@@ -724,5 +724,5 @@
 	$(MODEL_LIB)(sol_oce.o) \
 	$(MODEL_LIB)(tradmp.o) \
-	$() \
+	$(AGRIF_LIB) \
 	agrif_user.F90
 $(MODEL_LIB)(albedo.o) :	\
@@ -1160,5 +1160,5 @@
 	cpl_oce.F90
 \
-	$() $(MODEL_LIB)(daymod.o) :	\
+	$(AGRIF_LIB) $(MODEL_LIB)(daymod.o) :	\
 	dom_oce.F90 \
 	in_out_manager.F90 \
@@ -2594,5 +2594,5 @@
 	$(MODEL_LIB)(oce.o) \
 	$(MODEL_LIB)(prtctl.o) \
-	$() \
+	$(AGRIF_LIB) \
 	dynnxt.F90
 $(MODEL_LIB)(dynspg.o) :	\
@@ -2990,5 +2990,5 @@
 	domzgr_substitute.h90 \
 	vectopt_loop_substitute.h90 \
-	$() \
+	$(AGRIF_LIB) \
 	KEY_CPP \
 	dynspg_flt.F90
@@ -3109,5 +3109,5 @@
 	$(MODEL_LIB)(zdf_oce.o) \
 	domzgr_substitute.h90 \
-	$() \
+	$(AGRIF_LIB) \
 	KEY_CPP \
 	dynspg_flt_jki.F90
@@ -7641,5 +7641,5 @@
 	domzgr_substitute.h90 \
 	zdfddm_substitute.h90 \
-	$() \
+	$(AGRIF_LIB) \
 	KEY_CPP \
 	step.F90
@@ -8661,5 +8661,5 @@
 	$(MODEL_LIB)(prtctl.o) \
 	$(MODEL_LIB)(zdf_oce.o) \
-	$() \
+	$(AGRIF_LIB) \
 	tranxt.F90
 $(MODEL_LIB)(traqsr.o) :	\
Index: /trunk/UTIL/fait_AA_make
===================================================================
--- /trunk/UTIL/fait_AA_make	(revision 428)
+++ /trunk/UTIL/fait_AA_make	(revision 429)
@@ -523,8 +523,8 @@
 #-
 #- add dependancies with IOIPSL library (if source files contains Agrif_*)
-        grep -i 'use Agrif_*' ${fic} >/dev/null && ( echo "\\" ; echo "	\$($AGRIF_LIB) \c")
-
-#-
-#- on ajoute la dependance avecadd dependancies with KEY_CPP (if source file inclides cp  keys)
+        grep -i 'use Agrif_*' ${fic} >/dev/null && ( echo "\\" ; echo "	\$(AGRIF_LIB) \c")
+
+#-
+#- add dependancies with KEY_CPP (if source file inclides cp  keys)
 	if [ ${j} != "0" ] 
         then 
Index: /trunk/UTIL/fait_config
===================================================================
--- /trunk/UTIL/fait_config	(revision 428)
+++ /trunk/UTIL/fait_config	(revision 429)
@@ -126,5 +126,4 @@
     ln -sf ../../../*/${m_n}/scripts/BB_make AA_make ; 
     ln -sf ../../../*/${m_n}/scripts/BB_make.ldef AA_make.ldef ;
-    ln -sf ../../../*/${m_n}/scripts/BB_make_Agrif AA_make_Agrif ;
 
 else