Index: trunk/NEMO/OPA_SRC/SBC/flxmod.F90
===================================================================
--- trunk/NEMO/OPA_SRC/SBC/flxmod.F90	(revision 247)
+++ trunk/NEMO/OPA_SRC/SBC/flxmod.F90	(revision 440)
@@ -19,4 +19,13 @@
    !! * Routine accessibility
    PUBLIC flx       ! routine called by step.F90
+   PUBLIC flx_init  ! routine called by opa.F90
+
+   !! * local declarations
+   REAL(wp), PUBLIC ::            & !!! surface fluxes namelist (namflx)
+      q0    = 0.e0,               &  ! net heat flux
+      qsr0  = 0.e0,               &  ! solar heat flux
+      emp0  = 0.e0,               &  ! net freshwater flux
+      dqdt0 = -40.,               &  ! coefficient for SST damping (W/m2/K)
+      deds0 = 27.7                   ! coefficient for SSS damping (mm/day)
    
    !! * Substitutions
@@ -91,36 +100,56 @@
       !!   8.5  !  02-09  (G. Madec)  F90: Free form and module
       !!----------------------------------------------------------------------
-      !! * Modules used
-      USE flxrnf                       ! ocean runoffs
-
       !! * arguments
       INTEGER, INTENT( in  ) ::   kt   ! ocean time step
-
-      !! * local declarations
-      REAL(wp) ::                   & !!! surface fluxes namelist (namflx)
-         q0   = 0.e0,               &  ! net heat flux
-         qsr0 = 0.e0,               &  ! solar heat flux
-         emp0 = 0.e0                   ! net freshwater flux
-
-      NAMELIST/namflx/ q0, qsr0, emp0
       !!---------------------------------------------------------------------
 
-      IF( kt == nit000 ) THEN
-
-         ! Read Namelist namflx : surface thermohaline fluxes
-         ! --------------------
-         REWIND ( numnam )
-         READ   ( numnam, namflx )
-
+      IF( kt == nit000 )  THEN
          IF(lwp) WRITE(numout,*)' '
-         IF(lwp) WRITE(numout,*)' flx     : Constant surface fluxes read in namelist'
-         IF(lwp) WRITE(numout,*)' ~~~~~~~ '
-         IF(lwp) WRITE(numout,*)'      : See the routine ocesbc'     
-
-     ENDIF
+         IF(lwp) WRITE(numout,*)'flx     : Analytical/Constant surface fluxes'
+         IF(lwp) WRITE(numout,*)'~~~~~~~ '
+         IF(lwp) WRITE(numout,*)'          See the routine oce_sbc'     
+         IF(lwp) WRITE(numout,*)' '
+      ENDIF
 
    END SUBROUTINE flx
 
 #endif
-   !!======================================================================
+
+
+   SUBROUTINE flx_init
+      !!---------------------------------------------------------------------
+      !!                    ***  ROUTINE flx  ***
+      !!              
+      !! ** Purpose :   provide the thermohaline fluxes (heat and freshwater)
+      !!      to the ocean at each time step.
+      !!
+      !! ** Method  :   Constant surface fluxes (read in namelist (namflx))
+      !!
+      !! ** Action  : - q, qt, qsr, emp, emps, qrp, erp
+      !!
+      !! History :
+      !!        !  91-03  ()  Original code
+      !!   8.5  !  02-09  (G. Madec)  F90: Free form and module
+      !!----------------------------------------------------------------------
+      NAMELIST/namflx/ q0, qsr0, emp0, dqdt0, deds0
+      !!---------------------------------------------------------------------
+
+      ! Read Namelist namflx : surface thermohaline fluxes
+      ! --------------------
+      REWIND ( numnam )
+      READ   ( numnam, namflx )
+
+      IF(lwp) THEN
+         WRITE(numout,*)' '
+         WRITE(numout,*)'flx_init : thermohaline forcing '
+         WRITE(numout,*)'~~~~~~~~ '
+         WRITE(numout,*)'           net heat flux                  q0   = ', q0  , ' W/m2'
+         WRITE(numout,*)'           solar heat flux                qsr0 = ', qsr0, ' W/m2'
+         WRITE(numout,*)'           net heat flux                  emp0 = ', emp0, ' W/m2'
+         WRITE(numout,*)'           coefficient for SST damping   dqdt0 = ', dqdt0,' W/m2/K'
+         WRITE(numout,*)'           coefficient for SSS damping   deds0 = ', deds0,' mm/day'
+      ENDIF
+
+   END SUBROUTINE flx_init
+
 END MODULE flxmod